diff -urN punbb-1.3/include/functions.php punbb-1.3.4/include/functions.php
--- punbb-1.3/include/functions.php	2008-11-07 13:12:25.000000000 +0000
+++ punbb-1.3.4/include/functions.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads common functions used throughout the site.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -448,7 +448,7 @@
 		else
 		{
 			$links['search'] = '<li id="navsearch"'.((FORUM_PAGE == 'search') ? ' class="isactive"' : '').'><a href="'.forum_link($forum_url['search']).'">'.$lang_common['Search'].'</a></li>';
-			$links['profile'] = '<li id="navprofile"'.((FORUM_PAGE == 'editprofile' || FORUM_PAGE == 'viewprofile') ? ' class="isactive"' : '').'><a href="'.forum_link($forum_url['user'], $forum_user['id']).'">'.$lang_common['Profile'].'</a></li>';
+			$links['profile'] = '<li id="navprofile"'.((substr(FORUM_PAGE, 0, 7) == 'profile') ? ' class="isactive"' : '').'><a href="'.forum_link($forum_url['user'], $forum_user['id']).'">'.$lang_common['Profile'].'</a></li>';
 			$links['logout'] = '<li id="navlogout"><a href="'.forum_link($forum_url['logout'], array($forum_user['id'], generate_form_token('logout'.$forum_user['id']))).'">'.$lang_common['Logout'].'</a></li>';
 			$links['admin'] = '<li id="navadmin"'.((substr(FORUM_PAGE, 0, 5) == 'admin') ? ' class="isactive"' : '').'><a href="'.forum_link($forum_url['admin_index']).'">'.$lang_common['Admin'].'</a></li>';
 		}
@@ -631,7 +631,7 @@
 <div id="brd-debug" class="main">
 
 	<div class="main-head">
-		<h2><span><?php echo $lang_common['Debug table'] ?></span></h2>
+		<h2 class="hn"><span><?php echo $lang_common['Debug table'] ?></span></h2>
 	</div>
 
 	<div class="main-content debug">
@@ -937,10 +937,17 @@
 function get_scheme_packs()
 {
   	$schemes = array();
-
-	foreach (glob(FORUM_ROOT.'include/url/*') as $dirname)
-		if (is_dir($dirname) && file_exists($dirname.'/forum_urls.php'))
-			$schemes[] = basename($dirname);
+	
+	if($handle = opendir(FORUM_ROOT.'include/url'))
+	{
+		while (false !== ($dirname = readdir($handle)))
+		{
+			$dirname =  FORUM_ROOT.'include/url/'.$dirname;
+			if (is_dir($dirname) && file_exists($dirname.'/forum_urls.php'))
+				$schemes[] = basename($dirname);
+		}
+		closedir($handle);
+	}
 
 	($hook = get_hook('fn_get_scheme_packs_end')) ? eval($hook) : null;
 
@@ -952,12 +959,17 @@
 function get_style_packs()
 {
 	$styles = array();
-
-	foreach (glob(FORUM_ROOT.'style/*') as $dirname)
+	
+	if($handle = opendir(FORUM_ROOT.'style'))
 	{
-		$tempname = basename($dirname);
-		if (is_dir($dirname) && file_exists($dirname.'/'.$tempname.'.php'))
-			$styles[] = $tempname;
+		while (false !== ($dirname = readdir($handle)))
+		{
+			$dirname =  FORUM_ROOT.'style/'.$dirname;
+			$tempname = basename($dirname);
+			if (is_dir($dirname) && file_exists($dirname.'/'.$tempname.'.php'))
+				$styles[] = $tempname;
+		}
+		closedir($handle);
 	}
 
 	($hook = get_hook('fn_get_style_packs_end')) ? eval($hook) : null;
@@ -971,9 +983,16 @@
 {
 	$languages = array();
 
-	foreach (glob(FORUM_ROOT.'lang/*') as $dirname)
-		if (is_dir($dirname) && file_exists($dirname.'/common.php'))
-			$languages[] = basename($dirname);
+	if($handle = opendir(FORUM_ROOT.'lang'))
+	{
+		while (false !== ($dirname = readdir($handle)))
+		{
+			$dirname =  FORUM_ROOT.'lang/'.$dirname;
+			if (is_dir($dirname) && file_exists($dirname.'/common.php'))
+				$languages[] = basename($dirname);
+		}
+		closedir($handle);
+	}
 
 	($hook = get_hook('fn_get_language_packs_end')) ? eval($hook) : null;
 
@@ -1341,44 +1360,47 @@
 
 	$forum_user = $forum_db->fetch_assoc($result);
 
-	// Update online list
-	if (!$forum_user['logged'])
+	if (!defined('FORUM_QUIET_VISIT'))
 	{
-		$forum_user['logged'] = time();
-		$forum_user['csrf_token'] = random_key(40, false, true);
-		$forum_user['prev_url'] = get_current_url(255);
+		// Update online list
+		if (!$forum_user['logged'])
+		{
+			$forum_user['logged'] = time();
+			$forum_user['csrf_token'] = random_key(40, false, true);
+			$forum_user['prev_url'] = get_current_url(255);
 
-		// REPLACE INTO avoids a user having two rows in the online table
-		$query = array(
-			'REPLACE'	=> 'user_id, ident, logged, csrf_token',
-			'INTO'		=> 'online',
-			'VALUES'	=> '1, \''.$forum_db->escape($remote_addr).'\', '.$forum_user['logged'].', \''.$forum_user['csrf_token'].'\'',
-			'UNIQUE'	=> 'user_id=1 AND ident=\''.$forum_db->escape($remote_addr).'\''
-		);
+			// REPLACE INTO avoids a user having two rows in the online table
+			$query = array(
+				'REPLACE'	=> 'user_id, ident, logged, csrf_token',
+				'INTO'		=> 'online',
+				'VALUES'	=> '1, \''.$forum_db->escape($remote_addr).'\', '.$forum_user['logged'].', \''.$forum_user['csrf_token'].'\'',
+				'UNIQUE'	=> 'user_id=1 AND ident=\''.$forum_db->escape($remote_addr).'\''
+			);
 
-		if ($forum_user['prev_url'] != null)
-		{
-			$query['REPLACE'] .= ', prev_url';
-			$query['VALUES'] .= ', \''.$forum_db->escape($forum_user['prev_url']).'\'';
-		}
+			if ($forum_user['prev_url'] != null)
+			{
+				$query['REPLACE'] .= ', prev_url';
+				$query['VALUES'] .= ', \''.$forum_db->escape($forum_user['prev_url']).'\'';
+			}
 
-		($hook = get_hook('fn_set_default_user_qr_add_online_guest_user')) ? eval($hook) : null;
-		$forum_db->query_build($query) or error(__FILE__, __LINE__);
-	}
-	else
-	{
-		$query = array(
-			'UPDATE'	=> 'online',
-			'SET'		=> 'logged='.time(),
-			'WHERE'		=> 'ident=\''.$forum_db->escape($remote_addr).'\''
-		);
+			($hook = get_hook('fn_set_default_user_qr_add_online_guest_user')) ? eval($hook) : null;
+			$forum_db->query_build($query) or error(__FILE__, __LINE__);
+		}
+		else
+		{
+			$query = array(
+				'UPDATE'	=> 'online',
+				'SET'		=> 'logged='.time(),
+				'WHERE'		=> 'ident=\''.$forum_db->escape($remote_addr).'\''
+			);
 
-		$current_url = get_current_url(255);
-		if ($current_url != null)
-			$query['SET'] .= ', prev_url=\''.$forum_db->escape($current_url).'\'';
+			$current_url = get_current_url(255);
+			if ($current_url != null)
+				$query['SET'] .= ', prev_url=\''.$forum_db->escape($current_url).'\'';
 
-		($hook = get_hook('fn_set_default_user_qr_update_online_guest_user')) ? eval($hook) : null;
-		$forum_db->query_build($query) or error(__FILE__, __LINE__);
+			($hook = get_hook('fn_set_default_user_qr_update_online_guest_user')) ? eval($hook) : null;
+			$forum_db->query_build($query) or error(__FILE__, __LINE__);
+		}
 	}
 
 	$forum_user['disp_topics'] = $forum_config['o_disp_topics_default'];
@@ -1389,6 +1411,8 @@
 	$forum_user['style'] = $forum_config['o_default_style'];
 	$forum_user['is_guest'] = true;
 	$forum_user['is_admmod'] = false;
+
+	($hook = get_hook('fn_set_default_user_end')) ? eval($hook) : null;
 }
 
 
@@ -2572,9 +2596,9 @@
 	if (isset($_POST['confirm_cancel']))
 		redirect(forum_htmlencode($_POST['prev_url']), $lang_common['Cancel redirect']);
 
-		// A helper function for csrf_confirm_form. It takes a multi-dimensional array and returns it as a
+	// A helper function for csrf_confirm_form. It takes a multi-dimensional array and returns it as a
 	// single-dimensional array suitable for use in hidden fields.
-		function _csrf_confirm_form($key, $values)
+	function _csrf_confirm_form($key, $values)
 	{
 		$fields = array();
 
@@ -2756,7 +2780,7 @@
 	ob_start();
 
 ?>
-<title><?php echo $lang_common['Maintenance'].' - '.forum_htmlencode($forum_config['o_board_title']) ?></title>
+<title><?php echo $lang_common['Maintenance'].$lang_common['Title separator'].forum_htmlencode($forum_config['o_board_title']) ?></title>
 <link rel="stylesheet" type="text/css" media="screen" href="<?php echo $base_url ?>/style/<?php echo $forum_user['style'] ?>/<?php echo $forum_user['style'].'.css' ?>" />
 <link rel="stylesheet" type="text/css" media="screen" href="<?php echo $base_url ?>/style/<?php echo $forum_user['style'] ?>/<?php echo $forum_user['style'].'_cs.css' ?>" />
 <!--[if lte IE 6]><link rel="stylesheet" type="text/css" href="<?php echo $base_url ?>/style/<?php echo $forum_user['style'] ?>/<?php echo $forum_user['style'].'_fix.css' ?>" /><![endif]-->
@@ -2773,7 +2797,7 @@
 	ob_start();
 
 ?>
-<div id="brd-main" class="main basic">
+<div id="brd-maint" class="main basic">
 
 	<div class="main-head">
 		<h1 class="hn"><span><?php echo $lang_common['Maintenance mode'] ?></span></h1>
@@ -2868,7 +2892,7 @@
 	// START SUBST - <!-- forum_head -->
 
 	$forum_head['refresh'] = '<meta http-equiv="refresh" content="'.$forum_config['o_redirect_delay'].';URL='.str_replace(array('<', '>', '"'), array('&lt;', '&gt;', '&quot;'), $destination_url).'" />';
-	$forum_head['title'] = '<title>'.$lang_common['Redirecting'].' - '.forum_htmlencode($forum_config['o_board_title']).'</title>';
+	$forum_head['title'] = '<title>'.$lang_common['Redirecting'].$lang_common['Title separator'].forum_htmlencode($forum_config['o_board_title']).'</title>';
 
 	ob_start();
 
@@ -2947,14 +2971,16 @@
 // Display a simple error message
 function error()
 {
+	global $forum_config;
+
 	if (!headers_sent())
 	{
+		// if no HTTP responce code is set we send 503
+		if (!defined('FORUM_HTTP_RESPONSE_CODE_SET'))
+			header('HTTP/1.1 503 Service Temporarily Unavailable');
 		header('Content-type: text/html; charset=utf-8');
-		header('HTTP/1.1 503 Service Temporarily Unavailable');
 	}
 
-	global $forum_config;
-
 	/*
 		Parse input parameters. Possible function signatures:
 		error('Error message.');
@@ -2987,7 +3013,7 @@
 	while (@ob_end_clean());
 
 	// "Restart" output buffering if we are using ob_gzhandler (since the gzip header is already sent)
-	if (!empty($forum_config['o_gzip']) && extension_loaded('zlib') && (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false || strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'deflate') !== false))
+	if (!empty($forum_config['o_gzip']) && extension_loaded('zlib') && !empty($_SERVER['HTTP_ACCEPT_ENCODING']) && (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false || strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'deflate') !== false))
 		ob_start('ob_gzhandler');
 
 ?>
diff -urN punbb-1.3/include/parser.php punbb-1.3.4/include/parser.php
--- punbb-1.3/include/parser.php	2008-10-23 07:49:10.000000000 +0000
+++ punbb-1.3.4/include/parser.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads various functions used to parse posts.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -681,8 +681,8 @@
 
 	if (strpos($text, '[quote') !== false)
 	{
+		$text = preg_replace('#\[quote=(&quot;|"|\'|)(.*?)\\1\]#e', '"</p><div class=\"quotebox\"><cite>".str_replace(array(\'[\', \'\\"\'), array(\'&#91;\', \'"\'), \'$2\')." ".$lang_common[\'wrote\'].":</cite><blockquote><p>"', $text);
 		$text = preg_replace('#\[quote\]\s*#', '</p><div class="quotebox"><blockquote><p>', $text);
-		$text = preg_replace('#\[quote=(&quot;|"|\'|)(.*?)\\1\]#se', '"</p><div class=\"quotebox\"><cite>".str_replace(array(\'[\', \'\\"\'), array(\'&#91;\', \'"\'), \'$2\')." ".$lang_common[\'wrote\'].":</cite><blockquote><p>"', $text);
 		$text = preg_replace('#\s*\[\/quote\]#S', '</p></blockquote></div><p>', $text);
 	}
 
@@ -700,7 +700,7 @@
 
 	$replace[] = '<strong>$1</strong>';
 	$replace[] = '<em>$1</em>';
-	$replace[] = '<em class="bbuline">$1</em>';
+	$replace[] = '<span class="bbu">$1</span>';
 	$replace[] = '<span style="color: $1">$2</span>';
 	$replace[] = '</p><h5>$1</h5><p>';
 
@@ -752,7 +752,7 @@
 {
 	$text = ' '.$text;
 
-	$text = preg_replace('#(?<=[\s\]\)])(<)?(\[)?(\()?([\'"]?)(https?|ftp|news){1}://([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^\s\[]*[^\s.,?!\[;:-])?)\4(?(3)(\)))(?(2)(\]))(?(1)(>))(?![^\s]*\[/(?:url|img)\])#ie', 'stripslashes(\'$1$2$3$4\').handle_url_tag(\'$5://$6\', \'$5://$6\', true).stripslashes(\'$4$10$11$12\')', $text);
+	$text = preg_replace('#(?<=[\s\]\)])(<)?(\[)?(\()?([\'"]?)(https?|ftp|news){1}://([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^\s\[]*[^\s.,?!\[;:-]?)?)\4(?(3)(\)))(?(2)(\]))(?(1)(>))(?![^\s]*\[/(?:url|img)\])#ie', 'stripslashes(\'$1$2$3$4\').handle_url_tag(\'$5://$6\', \'$5://$6\', true).stripslashes(\'$4$10$11$12\')', $text);
 	$text = preg_replace('#(?<=[\s\]\)])(<)?(\[)?(\()?([\'"]?)(www|ftp)\.(([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^\s\[]*[^\s.,?!\[;:-])?)\4(?(3)(\)))(?(2)(\]))(?(1)(>))(?![^\s]*\[/(?:url|img)\])#ie', 'stripslashes(\'$1$2$3$4\').handle_url_tag(\'$5.$6\', \'$5.$6\', true).stripslashes(\'$4$10$11$12\')', $text);
 
 	return substr($text, 1);
@@ -766,6 +766,10 @@
 {
 	global $forum_config, $base_url, $smilies;
 
+	$return = ($hook = get_hook('ps_do_smilies_start')) ? eval($hook) : null;
+	if ($return != null)
+		return $return;
+
 	$text = ' '.$text.' ';
 
 	foreach ($smilies as $smiley_text => $smiley_img)
@@ -774,6 +778,8 @@
 			$text = preg_replace("#(?<=[>\s])".preg_quote($smiley_text, '#')."(?=\W)#m", '<img src="'.$base_url.'/img/smilies/'.$smiley_img.'" width="15" height="15" alt="'.substr($smiley_img, 0, strrpos($smiley_img, '.')).'" />', $text);
 	}
 
+	$return = ($hook = get_hook('ps_do_smilies_end')) ? eval($hook) : null;
+
 	return substr($text, 1, -1);
 }
 
diff -urN punbb-1.3/include/search_functions.php punbb-1.3.4/include/search_functions.php
--- punbb-1.3/include/search_functions.php	2008-10-30 13:04:00.000000000 +0000
+++ punbb-1.3.4/include/search_functions.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads various functions that are used for searching the forum.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -788,14 +788,14 @@
 		case 'show_user_posts':
 			$forum_page['crumbs'][] = sprintf($lang_search['Posts by'], $search_set[0]['pposter'], ($forum_page['start_from'] + 1), $num_hits);
 			$forum_page['items_info'] = generate_items_info($lang_search['Posts found'], ($forum_page['start_from'] + 1), $num_hits);
-			$forum_page['main_head_options']['user_topics'] = '<span'.(empty($forum_page['main_head_options']) ? ' class="first-item"' : '').'><a href="'.forum_link($forum_url['search_user_topics'], $search_id).'">'.sprintf($lang_search['Topics by'], $search_set[0]['pposter']).'</a></span>';
+			$forum_page['main_head_options']['user_topics'] = '<span'.(empty($forum_page['main_head_options']) ? ' class="first-item"' : '').'><a href="'.forum_link($forum_url['search_user_topics'], $search_id).'">'.sprintf($lang_search['Topics by'], forum_htmlencode($search_set[0]['pposter'])).'</a></span>';
 			$forum_page['main_head_options']['defined_search'] = '<span'.(empty($forum_page['main_head_options']) ? ' class="first-item"' : '').'><a href="'.forum_link($forum_url['search']).'">'.$lang_search['User defined search'].'</a></span>';
 			break;
 
 		case 'show_user_topics':
 			$forum_page['crumbs'][] = sprintf($lang_search['Topics by'], $search_set[0]['poster']);
 			$forum_page['items_info'] = generate_items_info($lang_search['Topics found'], ($forum_page['start_from'] + 1), $num_hits);
-			$forum_page['main_head_options']['user_posts'] =  '<span'.(empty($forum_page['main_head_options']) ? ' class="first-item"' : '').'><a href="'.forum_link($forum_url['search_user_posts'], $search_id).'">'.sprintf($lang_search['Posts by'], $search_set[0]['poster']).'</a></span>';
+			$forum_page['main_head_options']['user_posts'] =  '<span'.(empty($forum_page['main_head_options']) ? ' class="first-item"' : '').'><a href="'.forum_link($forum_url['search_user_posts'], $search_id).'">'.sprintf($lang_search['Posts by'], forum_htmlencode($search_set[0]['poster'])).'</a></span>';
 			$forum_page['main_head_options']['defined_search'] = '<span'.(empty($forum_page['main_head_options']) ? ' class="first-item"' : '').'><a href="'.forum_link($forum_url['search']).'">'.$lang_search['User defined search'].'</a></span>';
 			break;
 
diff -urN punbb-1.3/include/search_idx.php punbb-1.3.4/include/search_idx.php
--- punbb-1.3/include/search_idx.php	2008-11-05 12:42:27.000000000 +0000
+++ punbb-1.3.4/include/search_idx.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Load various functions used in indexing posts and topics for searching.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
diff -urN punbb-1.3/include/url/Default/forum_urls.php punbb-1.3.4/include/url/Default/forum_urls.php
--- punbb-1.3/include/url/Default/forum_urls.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.4/include/url/Default/forum_urls.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Regular URL scheme.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
diff -urN punbb-1.3/include/url/Default/reserved_strings.php punbb-1.3.4/include/url/Default/reserved_strings.php
--- punbb-1.3/include/url/Default/reserved_strings.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.4/include/url/Default/reserved_strings.php	2009-04-17 12:51:23.000000000 +0000
@@ -3,22 +3,22 @@
  * Loads the reserved strings used to transform problematic strings in URLs.
  * These are matched against the whole string after all other transformations.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 
 $forum_reserved_strings = array(
-	''		=>	'view',
+	''				=>	'view',
 
-	'newpost'	=>	'view',
-	'newposts'	=>	'view',
-	'new-post'	=>	'view',
-	'new-posts'	=>	'view',
+	'newpost'		=>	'view',
+	'newposts'		=>	'view',
+	'new-post'		=>	'view',
+	'new-posts'		=>	'view',
 
-	'lastpost'	=>	'view',
-	'lastposts'	=>	'view',
-	'last-post'	=>	'view',
+	'lastpost'		=>	'view',
+	'lastposts'		=>	'view',
+	'last-post'		=>	'view',
 	'last-posts'	=>	'view',
 );
diff -urN punbb-1.3/include/url/Default/rewrite_rules.php punbb-1.3.4/include/url/Default/rewrite_rules.php
--- punbb-1.3/include/url/Default/rewrite_rules.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.4/include/url/Default/rewrite_rules.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,17 +2,17 @@
 /**
  * Loads the regular expressions used to match SEF URL requests to their proper URLs.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 
 $forum_rewrite_rules = array(
-	'/^topic[\/_-]?([0-9]+).*(new|last)[\/_-]?(posts?)(\.html?|\/)?$/i'													=>	'viewtopic.php?id=$1&action=$2',
+	'/^topic[\/_-]?([0-9]+).*(new|last)[\/_-]?(posts?)(\.html?|\/)?$/i'														=>	'viewtopic.php?id=$1&action=$2',
 	'/^post[\/_-]?([0-9]+)(\.html?|\/)?$/i'																					=>	'viewtopic.php?pid=$1',
 	'/^(forum|topic)[\/_-]?([0-9]+).*[\/_-]p(age)?[\/_-]?([0-9]+)(\.html?|\/)?$/i'											=>	'view$1.php?id=$2&p=$4',
-	'/^feed[\/_-]?(rss|atom)[\/_-]?(f|t)(orum|opic)[\/_-]?([0-9]+)[\/_-]?(\.xml?|\/)?$/i'											=>	'extern.php?action=feed&$2id=$4&type=$1',
+	'/^feed[\/_-]?(rss|atom)[\/_-]?(f|t)(orum|opic)[\/_-]?([0-9]+)[\/_-]?(\.xml?|\/)?$/i'									=>	'extern.php?action=feed&$2id=$4&type=$1',
 	'/^(forum|topic)[\/_-]?([0-9]+).*(\.html?|\/)?$/i'																		=>	'view$1.php?id=$2',
 	'/^new[\/_-]?reply[\/_-]?([0-9]+)(\.html?|\/)?$/i'																		=>	'post.php?tid=$1',
 	'/^new[\/_-]?reply[\/_-]?([0-9]+)[\/_-]?quote[\/_-]?([0-9]+)(\.html?|\/)?$/i'											=>	'post.php?tid=$1&qid=$2',
@@ -44,7 +44,7 @@
 	'/^search-k(.*)-(message|subject|all)-a(.*)-([0-9]+)-(ASC|DESC)-([0-9-]+)-(posts|topics)-p([0-9]+).html?$/i'			=>	'search.php?action=search&keywords=$1&author=$3&forum=$6&search_in=$2&sort_by=$4&sort_dir=$5&show_as=$7&p=$8',
 	'/^users(\.html?|\/)?$/i'																								=>	'userlist.php',
 	'/^users\/(.*)\/([0-9-]+)\/?([a-z_]+)[\/_-]([a-zA-Z]+)[\/_-]p(age)?[\/_-]?([0-9]+)(\.html?|\/)?$/i'						=>	'userlist.php?username=$1&show_group=$2&sort_by=$3&sort_dir=$4&p=$6',
-	'/^users\/(.*)\/([0-9-]+)\/?([a-z_]+)[\/_-]([a-zA-Z]+)(\.html?|\/)?$/i'											=>	'userlist.php?username=$1&show_group=$2&sort_by=$3&sort_dir=$4',
+	'/^users\/(.*)\/([0-9-]+)\/?([a-z_]+)[\/_-]([a-zA-Z]+)(\.html?|\/)?$/i'													=>	'userlist.php?username=$1&show_group=$2&sort_by=$3&sort_dir=$4',
 	'/^(email|report|subscribe|unsubscribe)[\/_-]?([0-9]+)[\/_-]?([a-z0-9]+)?(\.html?|\/)?$/i'								=>	'misc.php?$1=$2&csrf_token=$3',
 	'/^(mark|rules)[\/_-]?(read)?[\/_-]?([a-z0-9]+)?(\.html?|\/)?$/i'														=>	'misc.php?action=$1$2&csrf_token=$3',
 	'/^mark[\/_-](forum)[\/_-]?([0-9]+)[\/_-](read)[\/_-]([a-z0-9]+)(\.html?|\/)?$/i'										=>	'misc.php?action=markforumread&fid=$2&csrf_token=$4',
diff -urN punbb-1.3/include/url/File_based/forum_urls.php punbb-1.3.4/include/url/File_based/forum_urls.php
--- punbb-1.3/include/url/File_based/forum_urls.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.4/include/url/File_based/forum_urls.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * SEF URLs that use a file-like layout.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
diff -urN punbb-1.3/include/url/File_based/reserved_strings.php punbb-1.3.4/include/url/File_based/reserved_strings.php
--- punbb-1.3/include/url/File_based/reserved_strings.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.4/include/url/File_based/reserved_strings.php	2009-04-17 12:51:23.000000000 +0000
@@ -3,22 +3,22 @@
  * Loads the reserved strings used to transform problematic strings in URLs.
  * These are matched against the whole string after all other transformations.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 
 $forum_reserved_strings = array(
-	''		=>	'view',
+	''				=>	'view',
 
-	'newpost'	=>	'view',
-	'newposts'	=>	'view',
-	'new-post'	=>	'view',
-	'new-posts'	=>	'view',
+	'newpost'		=>	'view',
+	'newposts'		=>	'view',
+	'new-post'		=>	'view',
+	'new-posts'		=>	'view',
 
-	'lastpost'	=>	'view',
-	'lastposts'	=>	'view',
-	'last-post'	=>	'view',
+	'lastpost'		=>	'view',
+	'lastposts'		=>	'view',
+	'last-post'		=>	'view',
 	'last-posts'	=>	'view',
 );
diff -urN punbb-1.3/include/url/File_based/rewrite_rules.php punbb-1.3.4/include/url/File_based/rewrite_rules.php
--- punbb-1.3/include/url/File_based/rewrite_rules.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.4/include/url/File_based/rewrite_rules.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,17 +2,17 @@
 /**
  * Loads the regular expressions used to match SEF URL requests to their proper URLs.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 
 $forum_rewrite_rules = array(
-	'/^topic[\/_-]?([0-9]+).*(new|last)[\/_-]?(posts?)(\.html?|\/)?$/i'													=>	'viewtopic.php?id=$1&action=$2',
+	'/^topic[\/_-]?([0-9]+).*(new|last)[\/_-]?(posts?)(\.html?|\/)?$/i'														=>	'viewtopic.php?id=$1&action=$2',
 	'/^post[\/_-]?([0-9]+)(\.html?|\/)?$/i'																					=>	'viewtopic.php?pid=$1',
 	'/^(forum|topic)[\/_-]?([0-9]+).*[\/_-]p(age)?[\/_-]?([0-9]+)(\.html?|\/)?$/i'											=>	'view$1.php?id=$2&p=$4',
-	'/^feed[\/_-]?(rss|atom)[\/_-]?(f|t)(orum|opic)[\/_-]?([0-9]+)[\/_-]?(\.xml?|\/)?$/i'											=>	'extern.php?action=feed&$2id=$4&type=$1',
+	'/^feed[\/_-]?(rss|atom)[\/_-]?(f|t)(orum|opic)[\/_-]?([0-9]+)[\/_-]?(\.xml?|\/)?$/i'									=>	'extern.php?action=feed&$2id=$4&type=$1',
 	'/^(forum|topic)[\/_-]?([0-9]+).*(\.html?|\/)?$/i'																		=>	'view$1.php?id=$2',
 	'/^new[\/_-]?reply[\/_-]?([0-9]+)(\.html?|\/)?$/i'																		=>	'post.php?tid=$1',
 	'/^new[\/_-]?reply[\/_-]?([0-9]+)[\/_-]?quote[\/_-]?([0-9]+)(\.html?|\/)?$/i'											=>	'post.php?tid=$1&qid=$2',
@@ -44,7 +44,7 @@
 	'/^search-k(.*)-(message|subject|all)-a(.*)-([0-9]+)-(ASC|DESC)-([0-9-]+)-(posts|topics)-p([0-9]+).html?$/i'			=>	'search.php?action=search&keywords=$1&author=$3&forum=$6&search_in=$2&sort_by=$4&sort_dir=$5&show_as=$7&p=$8',
 	'/^users(\.html?|\/)?$/i'																								=>	'userlist.php',
 	'/^users\/(.*)\/([0-9-]+)\/?([a-z_]+)[\/_-]([a-zA-Z]+)[\/_-]p(age)?[\/_-]?([0-9]+)(\.html?|\/)?$/i'						=>	'userlist.php?username=$1&show_group=$2&sort_by=$3&sort_dir=$4&p=$6',
-	'/^users\/(.*)\/([0-9-]+)\/?([a-z_]+)[\/_-]([a-zA-Z]+)(\.html?|\/)?$/i'											=>	'userlist.php?username=$1&show_group=$2&sort_by=$3&sort_dir=$4',
+	'/^users\/(.*)\/([0-9-]+)\/?([a-z_]+)[\/_-]([a-zA-Z]+)(\.html?|\/)?$/i'													=>	'userlist.php?username=$1&show_group=$2&sort_by=$3&sort_dir=$4',
 	'/^(email|report|subscribe|unsubscribe)[\/_-]?([0-9]+)[\/_-]?([a-z0-9]+)?(\.html?|\/)?$/i'								=>	'misc.php?$1=$2&csrf_token=$3',
 	'/^(mark|rules)[\/_-]?(read)?[\/_-]?([a-z0-9]+)?(\.html?|\/)?$/i'														=>	'misc.php?action=$1$2&csrf_token=$3',
 	'/^mark[\/_-](forum)[\/_-]?([0-9]+)[\/_-](read)[\/_-]([a-z0-9]+)(\.html?|\/)?$/i'										=>	'misc.php?action=markforumread&fid=$2&csrf_token=$4',
diff -urN punbb-1.3/include/url/File_based_(fancy)/forum_urls.php punbb-1.3.4/include/url/File_based_(fancy)/forum_urls.php
--- punbb-1.3/include/url/File_based_(fancy)/forum_urls.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.4/include/url/File_based_(fancy)/forum_urls.php	2009-04-17 12:51:23.000000000 +0000
@@ -3,7 +3,7 @@
  * SEF URLs that use a file-like layout and include topic name and forum name
  * where applicable.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
diff -urN punbb-1.3/include/url/File_based_(fancy)/reserved_strings.php punbb-1.3.4/include/url/File_based_(fancy)/reserved_strings.php
--- punbb-1.3/include/url/File_based_(fancy)/reserved_strings.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.4/include/url/File_based_(fancy)/reserved_strings.php	2009-04-17 12:51:23.000000000 +0000
@@ -3,22 +3,22 @@
  * Loads the reserved strings used to transform problematic strings in URLs.
  * These are matched against the whole string after all other transformations.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 
 $forum_reserved_strings = array(
-	''		=>	'view',
+	''				=>	'view',
 
-	'newpost'	=>	'view',
-	'newposts'	=>	'view',
-	'new-post'	=>	'view',
-	'new-posts'	=>	'view',
+	'newpost'		=>	'view',
+	'newposts'		=>	'view',
+	'new-post'		=>	'view',
+	'new-posts'		=>	'view',
 
-	'lastpost'	=>	'view',
-	'lastposts'	=>	'view',
-	'last-post'	=>	'view',
+	'lastpost'		=>	'view',
+	'lastposts'		=>	'view',
+	'last-post'		=>	'view',
 	'last-posts'	=>	'view',
 );
diff -urN punbb-1.3/include/url/File_based_(fancy)/rewrite_rules.php punbb-1.3.4/include/url/File_based_(fancy)/rewrite_rules.php
--- punbb-1.3/include/url/File_based_(fancy)/rewrite_rules.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.4/include/url/File_based_(fancy)/rewrite_rules.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,17 +2,17 @@
 /**
  * Loads the regular expressions used to match SEF URL requests to their proper URLs.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 
 $forum_rewrite_rules = array(
-	'/^topic[\/_-]?([0-9]+).*(new|last)[\/_-]?(posts?)(\.html?|\/)?$/i'													=>	'viewtopic.php?id=$1&action=$2',
+	'/^topic[\/_-]?([0-9]+).*(new|last)[\/_-]?(posts?)(\.html?|\/)?$/i'														=>	'viewtopic.php?id=$1&action=$2',
 	'/^post[\/_-]?([0-9]+)(\.html?|\/)?$/i'																					=>	'viewtopic.php?pid=$1',
 	'/^(forum|topic)[\/_-]?([0-9]+).*[\/_-]p(age)?[\/_-]?([0-9]+)(\.html?|\/)?$/i'											=>	'view$1.php?id=$2&p=$4',
-	'/^feed[\/_-]?(rss|atom)[\/_-]?(f|t)(orum|opic)[\/_-]?([0-9]+)[\/_-]?(\.xml?|\/)?$/i'											=>	'extern.php?action=feed&$2id=$4&type=$1',
+	'/^feed[\/_-]?(rss|atom)[\/_-]?(f|t)(orum|opic)[\/_-]?([0-9]+)[\/_-]?(\.xml?|\/)?$/i'									=>	'extern.php?action=feed&$2id=$4&type=$1',
 	'/^(forum|topic)[\/_-]?([0-9]+).*(\.html?|\/)?$/i'																		=>	'view$1.php?id=$2',
 	'/^new[\/_-]?reply[\/_-]?([0-9]+)(\.html?|\/)?$/i'																		=>	'post.php?tid=$1',
 	'/^new[\/_-]?reply[\/_-]?([0-9]+)[\/_-]?quote[\/_-]?([0-9]+)(\.html?|\/)?$/i'											=>	'post.php?tid=$1&qid=$2',
@@ -44,7 +44,7 @@
 	'/^search-k(.*)-(message|subject|all)-a(.*)-([0-9]+)-(ASC|DESC)-([0-9-]+)-(posts|topics)-p([0-9]+).html?$/i'			=>	'search.php?action=search&keywords=$1&author=$3&forum=$6&search_in=$2&sort_by=$4&sort_dir=$5&show_as=$7&p=$8',
 	'/^users(\.html?|\/)?$/i'																								=>	'userlist.php',
 	'/^users\/(.*)\/([0-9-]+)\/?([a-z_]+)[\/_-]([a-zA-Z]+)[\/_-]p(age)?[\/_-]?([0-9]+)(\.html?|\/)?$/i'						=>	'userlist.php?username=$1&show_group=$2&sort_by=$3&sort_dir=$4&p=$6',
-	'/^users\/(.*)\/([0-9-]+)\/?([a-z_]+)[\/_-]([a-zA-Z]+)(\.html?|\/)?$/i'											=>	'userlist.php?username=$1&show_group=$2&sort_by=$3&sort_dir=$4',
+	'/^users\/(.*)\/([0-9-]+)\/?([a-z_]+)[\/_-]([a-zA-Z]+)(\.html?|\/)?$/i'													=>	'userlist.php?username=$1&show_group=$2&sort_by=$3&sort_dir=$4',
 	'/^(email|report|subscribe|unsubscribe)[\/_-]?([0-9]+)[\/_-]?([a-z0-9]+)?(\.html?|\/)?$/i'								=>	'misc.php?$1=$2&csrf_token=$3',
 	'/^(mark|rules)[\/_-]?(read)?[\/_-]?([a-z0-9]+)?(\.html?|\/)?$/i'														=>	'misc.php?action=$1$2&csrf_token=$3',
 	'/^mark[\/_-](forum)[\/_-]?([0-9]+)[\/_-](read)[\/_-]([a-z0-9]+)(\.html?|\/)?$/i'										=>	'misc.php?action=markforumread&fid=$2&csrf_token=$4',
